//+------------------------------------------------+
//|                                                |
//|                                                |
//|                                                |
//+------------------------------------------------+
#property copyright ""
#property link      ""

//--------------------------------------------------------------------
extern double  Lot                  = 0.3;
extern int     StopLoss             = 20,
               TakeProfit           = 20,
               Risk                 = 5,   //   = 0    
               BarInPast            = 24;  //       High / Low
extern double  MovePower            = 10;  //  -    
extern bool    TradeOnlyInTime      = True;
extern int     StartHour            = 7,
               EndHour              = 15,
               CloseAllOrdersIn     = 18;                                    
                           
//--------------------------------------------------------------------
double  LOT, SL, TP, Quarter, Move;
int TimeBar, PinIndex, M, CloseIndex, I;
bool PinHigh, PinLow;

//--------------------------------------------------------------------
int start()
{
   if (TradeOnlyInTime==True&&Hour()>=CloseAllOrdersIn) CLOSEORDER();
   
   if (TradeOnlyInTime==True&&(Hour()<StartHour||Hour()>EndHour)) return; 
   if (TimeBar == Time[0]) return;
   if (TimeBar == 0) { TimeBar = Time[0]; return; }
   
   PinIndex = 0;
   
   if (Digits==2) M = 100;
   if (Digits==3) M = 1000;
   if (Digits==4) M = 10000;
   
   // -----------------------------------------------    10 
   CloseIndex = (Close[1]-Close[2])*M;
   if (CloseIndex<0) CloseIndex = CloseIndex*(-1);
   if (CloseIndex<=10) PinIndex++;                          // PinIndex = 1
   // --------------------------      10  
   if (PinIndex!=1) return;
   // ----------------------------------------------     
   Move    = High[1]-Low[1];
   if (Move<NormalizeDouble(MovePower*Point,Digits)) return; //    MovePower  
   
   Quarter = NormalizeDouble(Move/4, Digits);
   if (Open[1]>=(High[1]-Quarter)&&Close[1]>=(High[1]-Quarter))
      {PinIndex++;}
   if (Open[1]<=(Low[1]+Quarter)&&Close[1]<=(Low[1]+Quarter))
      {PinIndex++;}                                         // PinIndex = 2
   // -----------------------------------------------------------------------------
   if (PinIndex!=2) return;

   PinHigh = True;
   PinLow  = True;
   
   // -----------------------   High / Low   " "
   I = BarInPast;
   while (I>=2&&PinLow==True)
   {
     if (Low[I]<Low[1]) PinLow = False;
     I--;
   }
   
   if (PinLow==False)
   {
     I = BarInPast;
     while (I>=2&&PinHigh==True)
     {
       if (High[I]>High[1]) PinHigh = False;
       I--;
     }   
   } 
   else PinHigh = False;
   // -----------------------------------------------------------------------------
   if (PinLow==True)    // Buy
   {  
      TimeBar = Time[0];           
      if (TakeProfit!=0) TP  = NormalizeDouble(Ask + TakeProfit*Point,Digits); else TP = 0;
      if (StopLoss!=0)   SL  = NormalizeDouble(Bid - StopLoss*Point,Digits);   else SL = 0;   
      LOT = LOT(Risk,1);
      OPENORDER ("Buy");
   }
   
   if (PinHigh==True)   // Sell 
   {  
      TimeBar = Time[0];                         
      if (TakeProfit!=0) TP = NormalizeDouble(Bid - TakeProfit*Point,Digits); else TP = 0;
      if (StopLoss!=0)   SL = NormalizeDouble(Ask + StopLoss*Point,Digits);   else SL = 0;          
      LOT = LOT(Risk,1);    
      OPENORDER ("Sell");
   }

return(0);
}   

void CLOSEORDER()
{
   for (int i=0; i<OrdersTotal(); i++)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
         if (OrderSymbol()!=Symbol()) continue;

            OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),3,CLR_NONE);

      }   
   }
}

void OPENORDER(string ord)
{
   int error;
   if (ord=="Buy" ) error=OrderSend(Symbol(),OP_BUY, LOT,NormalizeDouble(Ask,Digits),3,SL,TP,"", 1,3);
   if (ord=="Sell") error=OrderSend(Symbol(),OP_SELL,LOT,NormalizeDouble(Bid,Digits),3,SL,TP,"",-1,3);
   if (error==-1)
   {  
      ShowERROR(error,0,0);
   }
return;
}               
//--------------------------------------------------------------------
void ShowERROR(int Ticket,double SL,double TP)
{
   int err=GetLastError();
   switch ( err )
   {                  
      case 1:                                                                               return;
      case 2:   Alert("       "              ,Ticket," ",Symbol());return;
      case 3:   Alert("Error      Ticket ",       Ticket," ",Symbol());return;
      case 130: Alert("Error     Ticket ",                 Ticket," ",Symbol());return;
      case 134: Alert("    ",                         Ticket," ",Symbol());return;
      case 146: Alert("Error    ",             Ticket," ",Symbol());return;
      case 129: Alert("Error   ",                      Ticket," ",Symbol());return;
      case 131: Alert("Error   ",                     Ticket," ",Symbol());return;
      case 4051:Alert("Error     ",Ticket," ",Symbol());return;
      case 4105:Alert("Error      ",                Ticket," ",Symbol());return;
      case 4063:Alert("Error    integer ",        Ticket," ",Symbol());return;
      case 4200:Alert("Error    ",                  Ticket," ",Symbol());return;
      default:  Alert("Error  " ,err,"   Ticket ",                     Ticket," ",Symbol());return;
   }
}
//--------------------------------------------------------------------
double LOT(int risk,int ord)
{
   double MINLOT = MarketInfo(Symbol(),MODE_MINLOT);
   if (Lot>0) LOT = Lot; else LOT = AccountFreeMargin()*risk/100/MarketInfo(Symbol(),MODE_MARGINREQUIRED)/ord;
   if (LOT>MarketInfo(Symbol(),MODE_MAXLOT)) LOT = MarketInfo(Symbol(),MODE_MAXLOT);
   if (LOT<MINLOT) LOT = MINLOT;
   if (MINLOT<0.1) LOT = NormalizeDouble(LOT,2); else LOT = NormalizeDouble(LOT,1);
   return(LOT);
}
//--------------------------------------------------------------------